// server.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "server.h"
#include "winsock.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define PORT 3021
#define MAX_MSG 100
#define LINE_ARRAY_SIZE (MAX_MSG+1)


/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		// TODO: code your application's behavior here.
		CString strHello;
		strHello.LoadString(IDS_HELLO);
		cout << (LPCTSTR)strHello << endl;
	}

	int listenSocket, i;
	unsigned short int listenPort = PORT;
	int clientAddressLength;
	struct sockaddr_in clientAddress, serverAddress;
	 char line[LINE_ARRAY_SIZE];

  	WSADATA     stWSAData;
	unsigned short wWSAVersion = 0x0101;
	int nRC = WSAStartup(wWSAVersion, &stWSAData);

	// Create socket for listening for client connection requests.
	listenSocket = socket(AF_INET, SOCK_DGRAM, 0);
	if (listenSocket < 0) {
	  cerr << "cannot create listen socket";
	  exit(1);
	}
  
	// Bind listen socket to listen port.  First set various fields in
	// the serverAddress structure, then call bind().
	// htonl() and htons() convert long integers and short integers
	// (respectively) from host byte order (on x86 this is Least
	// Significant Byte first) to network byte order (Most Significant
	// Byte first).
	serverAddress.sin_family = AF_INET;
	serverAddress.sin_addr.s_addr = htonl(INADDR_ANY);
	serverAddress.sin_port = htons(listenPort);
  
	if (bind(listenSocket,(struct sockaddr *) &serverAddress,sizeof(serverAddress)) < 0) {
		cerr << "cannot bind socket";
		exit(1);
	}

	// Wait for connections from clients.
	// This is a non-blocking call; i.e., it registers this program with
	// the system as expecting connections on this socket, and then
	// this thread of execution continues on.
	listen(listenSocket, 5);
  
	cout << "Waiting for request on port " << listenPort << "\n";

	while (1) {

		clientAddressLength = sizeof(clientAddress);

		// First set line to all zeroes, so we'll know where
		// the end of the string is.
		memset(line, 0x0, LINE_ARRAY_SIZE);
		int n;
		if ( (n=recvfrom(listenSocket, line, MAX_MSG, 0, (struct sockaddr *) &clientAddress, &clientAddressLength)) < 0) {
			cerr << "  I/O Problem";
			exit(1);
		}

		// show the client's IP address
		cout << "  from " << inet_ntoa(clientAddress.sin_addr);

		// Show the client's port number.
		cout << ":" << ntohs(clientAddress.sin_port) << "\n";

		// Show the line
//		cout << "  Received: " << line << "\n";
		cout << "  Received: 0x";

		// Convert line to upper case.
		for (i = 0; i < n; i++) {
//			line[i] = toupper(line[i]);
			printf("%x ", 0xff & line[i]);
		}
		cout << "\n";

//		// Send converted line back to client.
//		if (sendto(listenSocket, line, strlen(line) + 1, 0,(struct sockaddr *) &clientAddress,sizeof(clientAddress)) < 0)
//			cerr << "Error: cannot send modified data";

		memset(line, 0x0, LINE_ARRAY_SIZE);  // set line to all zeroes
	}
	
	WSACleanup();

	return nRetCode;
}


